"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _antd = require("antd");

require("../../../style/select_keyword.less");

/**
 * 关键字搜索
 */
var Option = _antd.Select.Option;
var SelectKeyWord = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var handleSelectChange = function handleSelectChange(data) {
    var onChange = props.onChange,
        value = props.value;
    onChange([data, value && value[1] ? value[1] : '']);
  };

  var handleInputChange = function handleInputChange(e) {
    var value = props.value,
        onChange = props.onChange;
    onChange([value[0], e.target.value]);
  };

  var keyWord = props.keyWord,
      value = props.value,
      hasDefaultOption = props.hasDefaultOption,
      defaultOptionValue = props.defaultOptionValue,
      defaultOptionText = props.defaultOptionText,
      allowClear = props.allowClear,
      keySpan = props.keySpan;
  return /*#__PURE__*/_react.default.createElement(_antd.Row, {
    className: "select-keyword",
    ref: ref
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: keySpan
  }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
    allowClear: allowClear,
    placeholder: "\u8BF7\u9009\u62E9",
    value: value && value[0] ? value[0] : [],
    onChange: handleSelectChange
  }, hasDefaultOption ? null : /*#__PURE__*/_react.default.createElement(Option, {
    value: defaultOptionValue
  }, defaultOptionText), keyWord.map(function (item) {
    return /*#__PURE__*/_react.default.createElement(Option, {
      key: item.value,
      value: item.value
    }, item.text);
  }))), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 24 - keySpan
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    allowClear: allowClear,
    value: value && value[1] ? value[1] : '',
    onChange: handleInputChange,
    placeholder: "\u8BF7\u8F93\u5165\u5173\u952E\u8BCD"
  })));
});
SelectKeyWord.propTypes = {
  keyWord: _propTypes.default.array.isRequired,
  onChange: _propTypes.default.func,
  value: _propTypes.default.array,
  hasDefaultOption: _propTypes.default.bool,
  defaultOptionText: _propTypes.default.string,
  defaultOptionValue: _propTypes.default.string,
  keySpan: _propTypes.default.number,
  allowClear: _propTypes.default.bool
};
SelectKeyWord.defaultProps = {
  defaultOptionValue: '',
  defaultOptionText: '请选择',
  allowClear: true,
  // 默认可清除
  keySpan: 11
};
var _default = SelectKeyWord;
exports.default = _default;